/*
 * @description: 
 * @Date: 2021-07-08 19:34:32
 * @LastEditors: am
 * @LastEditTime: 2021-07-29 11:35:00
 */
import { _decorator, Component, Label, RigidBody2D, Vec2, v2, view,Collider,UIOpacity,Collider2D,Contact2DType } from 'cc';
const { ccclass, property } = _decorator;

import GameControl from "./GameControl";
import GameUI from "./GameUI";
/**
 * 掉落盒子脚本，实现盒子碰撞及回收流程
 * 
 */

@ccclass('DropBox')
export default class DropBox extends Component {
    level: number = 1;
    level1: number = 1;
    static instance: DropBox;

    @property
    speed: number = 100;

    @property(Label)
    text: Label | null = null;
    rigid!: RigidBody2D;

    constructor() { super(); DropBox.instance = this; }
    onEnable(): void {
        var this_ = this;
        this.node.active = true;
        const opacityComp = this.getComponent(UIOpacity)!;
        opacityComp.opacity = 255;
        
        this.level = Math.round(Math.random() * 5) + 1;
        this.text!.string = this.level + "";

        this.node.setPosition(this.node.position.x, view.getVisibleSize().height);
       
    }
    
    start(){

        this.rigid = this.node.getComponent(RigidBody2D)!;
        // this.rigid.enabledContactListener = true;//开启2d碰撞
        // console.log('rigid',this.rigid);
        
         
        var Colliders = this.getComponent(Collider2D);
        if (Colliders) {
            Colliders.on(Contact2DType.BEGIN_CONTACT, this.onTriggerEnter, this);
            // console.log('开始监听');
            
        }

    }
    update(dt: any) {

    }
    async onTriggerEnter( selfCollider: any, otherCollider: { name: string; },contact: any) {
        
        // console.log('otherCollider',otherCollider);
        // console.log('otherCollider',otherCollider.name.split('<')[0]);
        
        if (otherCollider.name.split('<')[0] === "vbollet") {

            if (this.level >= 2) {
                this.level--;
                this.text!.string = this.level + "";
                GameControl.instance.SoundHit?GameControl.instance.SoundHit.play():'';
                this.rigid.linearVelocity = new Vec2(0, +15);
            } else {

                // console.log('box撞子弹 销毁box2');
                
                this.rigid.gravityScale = 0;
                this.rigid.linearVelocity = v2(0, 0);
                
                
                GameControl.instance.SoundDestroy?GameControl.instance.SoundDestroy.play():'';
                GameControl.instance.createAni(this.node.position.x, this.node.position.y);
                
                this.rigid.enabledContactListener = false;//开启2d碰撞
                // console.log('盒子isAwake',this.rigid.isAwake());
                this.rigid.sleep();
                // console.log('盒子isAwake2',this.rigid.isAwake());
                
                setTimeout(()=>{
                    if(this.node){
                        this.node.active=false;
                        GameControl.instance.createdBox(this.node);

                        // this.destroy(); //销毁会把事件去掉让下次重新用的时候麻烦
                    }
                },10)
                
            }
            GameUI.instance.addScore(1);
        } else if (otherCollider.name.split('<')[0] === "ground") {
            // console.log('地面');
            
            this.rigid.enabledContactListener = false;//开启2d碰撞
            this.rigid.sleep();
            setTimeout(()=>{

                GameControl.instance.createdBox(this.node);

            },10)
            // console.log('销毁box3 地面');
            
            this.rigid.gravityScale = 0;
            this.rigid.linearVelocity = v2(0, 0);
            
            // this.destroy(); //销毁会把事件去掉让下次重新用的时候麻烦
            // console.log('停止');
            GameUI.instance.stopGame();
        }
    }
    onDisable(): void {
        // var Colliders = this.getComponent(Collider2D)!;
        // Colliders.off(Contact2DType.BEGIN_CONTACT, this.onTriggerEnter, this);

        // console.log('盒子消失Colliders',Colliders);
        // console.log('盒子消失');
        // console.log(this.node.active);
    }
}

