// import { _decorator, Component, Prefab, Node, AudioSource, NodePool } from 'cc';
import * as cc from 'cc';
const { ccclass, property } = cc._decorator;

import DropBox from "./DropBox";
import Bullet from "./Bullet";
import Jieshu from "./jieshu";
import blast from "./blast";
import GameUI from "./GameUI";

@ccclass('GameControl')
export default class GameControl extends cc.Component {
    @property(cc.Prefab)
    dropBox!: cc.Node;
    @property(cc.Prefab)
    bullet!: cc.Node;

    @property(cc.Prefab)
    jieshu!: cc.Node;
    @property(cc.AudioSource)
    SoundHit!: cc.AudioSource;
    @property(cc.AudioSource)
    SoundDestroy!: cc.AudioSource;
    @property(cc.Node)
    effect!: cc.Node;
    // @property(cc.Node)
    // dragonBonesControl!: cc.Node;
    createBoxInterval: number = 250;
    /** 设置单例的引用方式 ， 方便其他类引用 dnahluv */
    static instance: GameControl;
    /**开始时间*/
    private _time: number = 0;
    /**是否已经开始游戏 */
    private _started: boolean = false;
    /**子弹和盒子所在的容器对象 */
    private gameBox!: cc.NodePool;
    private gameBullet!: cc.NodePool;
    /** fdsfdsfsd */
    private animationPool!: cc.NodePool;
    oneBullet!: cc.Node;
    oneBox!: cc.Node;
    oneani!: cc.Node;

    constructor() { super(); GameControl.instance = this; }
    onEnable(): void {
        // cc.director.getCollisionManager().enabled = true;
        // cc.director.getCollisionManager().enabledDebugDraw = true;
        this._time = Date.now();
        this.gameBox = new cc.NodePool('DropBox');
        this.gameBullet = new cc.NodePool('Bullet');
        this.animationPool = new cc.NodePool('blast');
    }
    onLoad() {
        // blast.instance.node.active = false;
        this.enabled = false;
    }
    start(){
        console.log('开始');
        this.createBox();
        
        cc.find('Canvas')!.on(cc.Node.EventType.MOUSE_MOVE, this.onMouseMove, this);
        // cc.find('Canvas').on(cc.Node.EventType.TOUCH_MOVE, this.onMouseMove, this);
        // cc.find('Canvas').on(cc.Node.EventType.TOUCH_END, this.onMouseMove, this);
        
        // if (cc.PhysicsSystem2D.instance) {
        //     cc.PhysicsSystem2D.instance.on(cc.Contact2DType.BEGIN_CONTACT, this.onBeginContact, this);
        // }
    }
    onBeginContact( selfCollider: any, otherCollider:any,contact: any){

        console.log('otherCollider',otherCollider);
        
    }
    update(): void {
        //每间隔一段时间创建一个盒子
        let now = Date.now();
        if (now - this._time > this.createBoxInterval) {
            this._time = now;
            this.createBox();
        }

    }
    /**
     * @description: 爆炸效果
     * @param {number} x
     * @param {number} y
     * @return {*}
     * @author_: am
     */
    createAni(x: number, y: number): void {
        if(!this._started)return;
        var scene = cc.director.getScene();
        // this.oneani = this.animationPool.get();
        // if (this.animationPool.size()>0) {
        //     this.oneani= this.animationPool.get(this)
        // }else{
        this.oneani = cc.instantiate(this.effect);
        this.animationPool.put(this.oneani);
        // }
        this.oneani.setPosition(x, y);
        this.oneani.on('finished', function () {
            console.log('finished');
        })
        this.oneani.active = true;
        if (!this.oneani.parent) {
            this.node.addChild(this.oneani);
        }
    }
    createBox(): void {
        if(!this._started)return;
        this.oneBox = this.gameBox.get(this.dropBox)!;
        if (this.gameBox.size()>0) {
            this.oneBox=this.gameBox.get(this.dropBox)!;
            var rigid = this.oneBox.getComponent(cc.RigidBody2D)!;
            rigid.enabledContactListener = true;//开启2d碰撞
            if(!rigid.isAwake()){
                rigid.wakeUp();
                rigid.gravityScale=1;
                rigid.linearDamping=0.5;
                // rigid.angularVelocity=100;
                // console.log('rigid叫醒的',rigid);
            }
        }else{
            this.oneBox = cc.instantiate(this.dropBox);
            this.gameBox.put(this.oneBox);
        }
        this.oneBox.setPosition(new cc.Vec3(Math.random() * (cc.view.getVisibleSize().width - 100), this.oneBox.position.y));

        // console.log('对象池盒子',this.gameBullet._pool.length);
        this.oneBox.active = true;
        if (!this.oneBox.parent) {
            this.node.addChild(this.oneBox);
        }
    }
    /**
     * @description: 用对象池 从父节点删除
     * @param {cc} gameBox 产生box的对象池
     * @param {cc} box
     * @return {*}
     * @author_: am
     */
    createdBox(box: cc.Node) {
        if(this.gameBox)this.gameBox.put(box);
    }
    clearAni(box: any) {
        if(!this._started)return;
        if (this.enabled) {
            this.animationPool.put(box);
        }
        // var ss=this.animationPool.size();
        // console.log(ss);
    }
    createdJieshu1(bullet: cc.Node) {

        if(this.gameBullet)this.gameBullet!.put(bullet!);
        
    }
    // onStageClick(e: cc.Event): void {
    onMouseMove(event: cc.Event): void {
        // console.log('Event',event.getLocationInView());
        // 停止事件冒泡，提高性能，当然也可以不要
        // event.stopPropagation();
        var touchLoc =event.getLocation();
        // console.log(' this.touchLoc', touchLoc);

        //舞台被点击后，使用对象池创建子弹
        // var scene = cc.director.getScene();
        // for(let i =1;i<8;i++){
        this.oneBullet = this.gameBullet.get(this.bullet)!;
        

        // console.log('移动时有多少个',this.gameBullet.size());

        if (this.gameBullet.size() > 0) {
            // console.log('>0');
            this.oneBullet = this.gameBullet.get(this.bullet)!;

            var rigid = this.oneBullet.getComponent(cc.RigidBody2D)!;
            rigid.enabledContactListener = true;//开启2d碰撞
            if(!rigid.isAwake()){
                rigid.wakeUp();
                rigid.linearVelocity=new cc.Vec2(0,14);
            }


        } else {
            this.oneBullet = cc.instantiate(this.bullet);
            this.gameBullet.put(this.oneBullet);

        }
        this.oneBullet.setPosition(touchLoc.x,touchLoc.y);
        
        // console.log('position',this.oneBullet.position);
        
        // console.log('对象池子弹',this.gameBullet);

        
        this.oneBullet.active = true;
        if (!this.oneBullet.parent) {
            this.node.addChild(this.oneBullet);
            // console.log('this.node',this.node);
        }
        // }
    }
    /**开始游戏，通过激活本脚本方式开始游戏*/
    startGame(): void {
        console.log('开始111');
        this.onEnable();
        if (!this._started) {
            cc.assetManager.assets.clear()
            console.log('this.node000',this.node.children);
            console.log('Cache 缓存数量',cc.assetManager.assets);
            
            // cc.PhysicsSystem2D.instance.enable = true;
            this._started = true;
            this.enabled = true;
        }
    }
    /**结束游戏，通过非激活本脚本停止游戏 */
    stopGame(): void {
        // if(this.node){
        //     this.node.active = false;
        //     this.node.destroyAllChildren();
        // }
        for (let i = 0; i < 100; i++) {
            clearTimeout(i)
        }
        // console.log('结束');

        // cc.find('Canvas').off(cc.Node.EventType.TOUCH_MOVE, this.onMouseMove, this);
        cc.find('Canvas')!.off(cc.Node.EventType.MOUSE_MOVE, this.onMouseMove, this);
        this.createBoxInterval = 500;
        this._started = false;
        // cc.PhysicsSystem2D.instance.enable = false;

        // cc.assetManager.releaseAll();
        cc.assetManager.assets.clear()
        
        console.log('销毁一切');
        console.log('Cache 缓存数量',cc.assetManager.assets);
        // console.log('Cache 缓存数量',cc.assetManager.bundles);

        this.destroy()
        setTimeout(()=>{
            console.log('this.node222',this.node);
        })
        
        // cc.director.getCollisionManager().enabled = false;
        // cc.director.getCollisionManager().enabledDebugDraw = false;
    }
}

