//scorpio-nan

// import { _decorator, Component, Label, Sprite, SpriteFrame } from 'cc';
import * as cc from 'cc';

const { ccclass, property } = cc._decorator;

import GameControl from "./GameControl";
import DropBox from "./DropBox";
/**
 * 
 * 
 */

@ccclass('GameUI')
export default class GameUI extends cc.Component {
    @property(cc.Label)
    scoreLbl: cc.Label | null = null;
    @property(cc.Label)
    tipLbll!: cc.Label;
    shudu = 100;
    @property(cc.Label)
    testNode: cc.Label | null = null;
    @property(cc.Sprite)
    mySprite: cc.Sprite | null = null;
    @property([cc.SpriteFrame])
    mySpriteList: cc.SpriteFrame[] = [];
    frame: any = null;
    /** 设置单例的引用方式 ， 方便其他类引用 dnahluv */
    static instance: GameUI;
    /**当前游戏积分字段 */
    private _score!: number;
    /**游戏控制脚本引用，避免每次获取组件带来不必要的性能开销 */
    private _control!: GameControl;
    constructor() {
        super();
        GameUI.instance = this;
    }
    start() {
        var self = this;
        console.log('开始1');

        // 异步加载
        cc.resources.load("mm", cc.SpriteFrame, function (err, spriteFrame) {
            console.log('spriteFrame',spriteFrame);
            // spriteFrame!.addRef();
            self.frame = spriteFrame;
            console.log('tuuuuuuu', self.frame);

            self.mySprite!.spriteFrame = self.frame;

            setTimeout(() => {
                self.mySprite!.spriteFrame = self.mySpriteList[0];
            }, 800)

        });

    }
    onEnable(): void {
        console.log('加载');
        var self = this;

        //同步加载
        // var s = "resources/mm.jpg"
        // self.frame = new cc.SpriteFrame(cc.url.raw(s));


        var ws = new WebSocket("ws://127.0.0.1:9000");
        ws.onopen = function (event) {
            console.log("打开");
        };
        ws.onmessage = function (event) {
            console.log("消息response text msg: " + event.data);
        };
        ws.onerror = function (event) {
            console.log("错误Send Text fired an error");
        };
        ws.onclose = function (event) {
            console.log("关闭WebSocket instance closed.");
        };

        setTimeout(function () {
            console.log(ws.readyState);
            console.log(WebSocket);

            if (ws.readyState === WebSocket.OPEN) {
                ws.send("打开Hello WebSocket, I'm a text message.");
            }
            else {
                console.log("没准备WebSocket instance wasn't ready...");
            }
        }, 3);







        // cc.systemEvent.on(cc.SystemEvent.EventType.KEY_DOWN, function(){
        //     console.log('15');
        // }, this)


        //   cc.director.getPhysicsManager().debugDrawFlags = cc.PhysicsManager.DrawBits.e_jointBit
        // cc.PhysicsManager.DrawBits.e_pairBit |
        // cc.PhysicsManager.DrawBits.e_centerOfMassBit |
        // cc.PhysicsManager.DrawBits.e_jointBit |
        // cc.PhysicsManager.DrawBits.e_shapeBit
        // cc.director.loadScene("play");
        this._control = GameControl.instance;
        console.log("开始");
        //点击提示文字，开始游戏
        var canvas = cc.find("Canvas");
        this.tipLbll!.node.on(cc.Node.EventType.TOUCH_START, this.onTipClick, this);
        cc.director.preloadScene("helloworld");
        // canvas.on('mousedown', this.onTipClick,this);
    }
    onTipClick(e: any): void {
        this.tipLbll.node.active = false;
        this._score = 0;
        this.scoreLbl!.string = "";
        this._control.startGame();
    }
    /*  */
    /**增加分数 */
    addScore(value: number = 1): void {
        this._score += value;
        this.scoreLbl!.string = "分数：" + this._score;
        //随着分数越高，难度增大
        if (this._control.createBoxInterval > 20 && this._score % 100 == 0)
            this._control.createBoxInterval -= 20;
        if (this._score % 20 == 0) this.shudu += 30;
    }
    /**停止游戏 */
    stopGame(): void {
        this.tipLbll.node.active = true;
        this.tipLbll.string = "准备好， 点击开始";
        cc.director.loadScene("helloworld");
        this._control.stopGame();
    }
}

